#include <File_Archiver.h>

using namespace inaf::oasbo::Archivers;

FileArchiverBuilder::FileArchiverBuilder() {
	this->reset();
}
FileArchiverBuilder::FileArchiverBuilder(std::string dest) {
	this->arch = new FileArchiver(dest);
}
FileArchiverBuilder::FileArchiverBuilder(std::string parent, std::string dest) {
	this->arch = new FileArchiver(parent, dest);
}
FileArchiverBuilder::~FileArchiverBuilder() {
	delete arch;
}

void FileArchiverBuilder::reset() {
	this->arch = new FileArchiver();
}

FileArchiverBuilder* FileArchiverBuilder::configFrom(Configurators::BaseConfigurator *conf) {
	conf->readConfigFromSource(config_target);
	std::map<std::string, std::string> params = conf->getConfig();

	std::string key = config_target+"_"+archive_path_key;
	if (params.count(key) > 0)
		arch->parentPath = params[key];

	key = config_target+"_"+file_name_key;
	if (params.count(key) > 0)
		arch->setDest(params[key]);
	return this;
}

FileArchiverBuilder* FileArchiverBuilder::setParent(std::string parent) {
	arch->parentPath = parent;
	return this;
}

FileArchiverBuilder* FileArchiverBuilder::setDest(std::string dest) {
	arch->setDest(dest);
	return this;
}

FileArchiver* FileArchiverBuilder::getArchiver() {
	FileArchiver *result = this->arch;
	this->reset();
	return result;
}
